class MHTune expands Mutator;

#exec OBJ LOAD FILE=..\System\MonsterHunt.u Package="MonsterHunt"

var bool bInitialized, bNoBullshit, bDoneFactories, bNavig;
var int CurrentID;
var float Clock;

event PreBeginPlay()
{
}

event PostBeginPlay()
{
	log (Self$": I have ignited trash removal...");
//	Clock = appSeconds();
	RuinStupidStuff();
	SolveCounter();
	ConsoleCommand("obj garbage");
//	Clock = appSeconds() - Clock;
//	log ("Finished Tweaking in "$Clock$" seconds.");
/*
	if ( (ConsoleCommand("get ini:Engine.Engine.GameEngine bHackedEngine") ~= GetPropertyText("bTrue"))
	&& int(ConsoleCommand("get ini:Engine.Engine.GameEngine Version")) >= 12 )
	default.bUseXCGE10=True;

	if ( !default.bUseXCGE10 )
		Warn("Cannot use this feature.");
	else
		bUsableClock=True;
	if (bUsableClock)
		Clock = appSeconds();
	if (bUsableClock)
	{

	}
*/
	if ( !bInitialized )
	{
		bInitialized = True;
		Level.Game.RegisterDamageMutator(Self);
		SetTimer(1/Level.TimeDilation,false);
	}
	else
	{
		log (Self$" already running...");
		return;
	}
}

event timer()
{
	local ThingFactory T;
	local NavigationPoint N;
	local int NAc;

//---------
//	Clock = AppSeconds();

	if (!bDoneFactories)
	{
		foreach AllActors(class'ThingFactory',T)
		{
			if ( T != None )
			{
				T.bOnlyPlayerTouched = True;
				if (T.prototype == class'Botpack.PulseGun')
				{
					T.prototype = class'MonsterHunt.EPulseGun';
					T.Capacity = 1;
					log (T@"adjusted to"@T.prototype);
				}
				if (T.prototype == class'Botpack.minigun2')
				{
					T.prototype = class'MonsterHunt.Eminigun2';
					T.Capacity = 1;
					log (T@"adjusted to"@T.prototype);
				}
				if (T.prototype == class'Botpack.UT_Eightball')
				{
					T.prototype = class'MonsterHunt.EUT_Eightball';
					T.Capacity = 1;
					log (T@"adjusted to"@T.prototype);
				}
			}
		}
		bDoneFactories = True;
//		Clock = AppSeconds() - Clock;
//		Log("Time needed to execute: "$Clock);
	}

//------------
	if ( Level.Game.CurrentID > CurrentID )
		DetectNewPlayers();
	SetTimer( 1/Level.TimeDilation,false );
	if (!bNavig)
	{
//		Clock = AppSeconds();
		NAc=0;
//		foreach AllActors (class 'NavigationPoint',N)
		for ( N=Level.NavigationPointList; N!=None; N=N.NextNavigationPoint )
		{
			if (N != None) NAc++;
		}
		log ("This Level has"@NAc@"Navigation Points.");
//		Clock = appSeconds() - Clock;
//		log ("Finished Navigation Check in "$Clock$" seconds.");
		bNavig=True;
	}
}

function DetectNewPlayers()
{
	local pawn P;
	local Actor A;
	local int Nac;

	foreach AllActors(class'Pawn',P)
//	For ( P=Level.PawnList ; P!=none ; P=P.nextPawn )
	if ( P != None && MessagingSpectator(P) == None && P.PlayerReplicationInfo != none )
	{
		if ( P.PlayerReplicationInfo.PlayerID >= CurrentID )
		{
			AddWatcher(P);
		}
		else
			break;
	}
	CurrentID = Level.Game.CurrentID;
//	Clock = appSeconds() - Clock;
//	log ("Finished Pawnlist in "$Clock$" seconds.");
}

function AddWatcher( Pawn P)
{
	P.Spawn( class'WatchIt',P,,,);
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	local Pawn P;
	local Weapon W;

	if ( Other.bIsPawn && Pawn(Other).PlayerReplicationInfo == None )
		return True;

	if ( Decoration(Other) != None )
	{
		if ( Other.bNoDelete || Other.bStatic )
			Decoration(Other).bProjTarget = False;
	}
	if ( Ammo(Other) != None && !Other.Region.Zone.bWaterZone)
	{
		if ( Ammo(Other).MyMarker != None && (Ammo(Other).RespawnTime < 1 || Ammo(Other).RespawnTime > 4 ) )
			Ammo(Other).RespawnTime = 4;
	}

	if ( Pickup(Other) != None )
	{
		if (Other.Region.Zone.bWaterZone)
			Pickup(Other).RespawnTime=RandRange(120,180);
		else
		{
			if (Pickup(Other).IsA('Weapon'))
				Pickup(Other).MaxDesireability=Pickup(Other).MaxDesireability += 1;
		}
	}

	if ( Weapon(Other) != None && Weapon(Other).Instigator != None && Weapon(Other).Instigator.Weapon != Weapon(Other) )
	{
		P = Weapon(Other).Instigator;
		W = Weapon(Other);
		if ( P.Health > 0 && P.PlayerReplicationInfo == None )
		{
			log ("Attempt to solve "$P.GetHumanName()$" with weapon "$W$".");
			spawn (class'PawnControl',P,,P.Location);
		}
// Crap completed for XidiaBullShitRifle still letting Skaarj unarmed in 2015, LOL penguins... HellFireV3 OLOLOL
// Someone was shitting animations there, a faster weapon deal simply bugs things out - an the rest of default stuff WORKS FINE
// It was "Properly" coded UTMHPack - AKA other shit pack - I'm wiping my a$$ with that supposed "helper"
	}
/*
	if ( Pawn(Other) != None && Pawn(Other).PlayerReplicationInfo == None )
	{
		if (P.Inventory != None && Weapon(P.Inventory) != None && P.Weapon != Weapon(P.Inventory))
		{
			Weapon(P.Inventory).SetLocation(P.Location);
			P.bIsPlayer = True;
			Weapon(P.Inventory).Touch(P);
			P.bIsPlayer = False;
		}
	}
*/
	bSuperRelevant = 0;
	return true;
}

function bool PreventDeath(Pawn Killed, Pawn Killer, name damageType, vector HitLocation)
{
	local ScriptedPawn S, oS;
	local Pawn P, Pw;
	local Bird1 Fake;
	local bool bCrapSpawned;
	local Actor T;

	if ( Killed != None )
	{
		if ( Killed.PlayerReplicationInfo == None )
		{
			foreach Killed.RadiusActors (class'Actor',T,700)
			{
				if ( T != None )
				{
					foreach T.TouchingActors(class'Pawn',P)
					{
						if ( P != None && P == Killed && T.Tag != '' && Killed.Event != T.Tag )
							T.UnTouch( Killed );
					}
/*
					for (i=0;i<4;i++)
					{
						if (T.Touching[i] == Killed && !T.IsA('Mover') && Killed.Event != T.Tag)
							T.UnTouch( Killed );
					
						if (T.IsA('Mover') && Mover(T).Instigator != None && Mover(T).Instigator == Killed && !Mover(T).bTriggerOnceOnly && Killed.Event != Mover(T).Tag )
							Mover(T).UnTrigger(Killed,Instigator);
					}
*/
				}
			}
			if ( !Killed.IsInState('Dying') )
				Killed.GoToState('Dying');
		}
		else
		{
			if ( !bCrapSpawned )
			{
				Fake = Spawn(class'Bird1',,,Killed.Location+vect(0,0,80));
				if ( Fake != None )
				{
					Fake.DrawScale = 0.5;
					Fake.LifeSpan = 10.0;
					Fake.Health = 300;
					Fake.bCircle = True;
					Fake.CircleRadius = 100;
					Fake.AnimSequence = 'Flight';
					Fake.ReducedDamageType = 'All';
					Fake.bHidden = True;
					bCrapSpawned = True;
				}
			}
			for ( P=Level.PawnList; P!=None; P=P.nextPawn )
//			foreach AllActors (class 'ScriptedPawn',oS)
			{
//				oS = ScriptedPawn(P);
//				log ("#1");
				if ( oS != None && oS != Killed && ( oS.Enemy == Killed || oS.Target == Killed ) && oS.Health > 0 )
				{
//					Log (oS$" Has Enemy "$oS.Enemy.GetHumanName());
//					Log (oS$" Has Target "$oS.Target.GetHumanName());
//					log ("#2");
					if (bCrapSpawned)
					{
//						log ("#3");
						oS.Enemy = Fake;
						oS.Target = Fake;
						if ( oS.IsInstate('TacticalMove') ) //Not helps anyway, fuckward still bitching
							oS.WhatToDoNext('Waiting','');
					}
					else
					{
//						log ("#4");
						if ( oS.OldEnemy != None && oS.Enemy == None ) //Not really happens :(
							oS.Enemy = oS.OldEnemy;
						else
						{
//							log ("#5");
							for ( Pw=Level.PawnList; Pw!=None; Pw=Pw.nextPawn )
							{
								if ( Pw != None && Pw != oS && Pw != Killed
									&& Pw.Health > 0 && Pw.PlayerReplicationInfo != None && Pw.Mesh != None
										&& oS.Enemy == None )
											oS.Enemy = Pw;
//								log ("#5");
							}
							if ( Fly(oS) != None )
							if ( oS.Enemy == None || oS.Enemy.Health < 0 ) //if still no enemy damage yourself not the game, faggot.
								oS.Enemy = oS; //Technically shouldn't be problem but it's EPIC, and for this reason IT IS a problem.
//									log ("#6");
//							log (oS$" has enemy "$oS.Enemy.GetHumanName());
						}
					}
				}
			}
		}
		DropInventory(Killed);
	}
	if ( NextMutator != None )
		return NextMutator.PreventDeath(Killed,Killer,damageType,HitLocation);
	return false;
}

function DropInventory (Pawn Killed)
{
	local Weapon Wo, We;
	local int DropPitch;
	local int DropYaw;
	local Rotator DropRot;

	if (Killed.Weapon == None)
	{
//		log (Killed$" doesn't have weapon.");
		return;
	}
	else
	{
		Wo = Killed.Weapon;
		if ( Wo != None && Wo.AmmoType != None 
			&& Wo.AmmoType.AmmoAmount > 0
				&& Wo.Class != Level.Game.BaseMutator.MutatedDefaultWeapon()
					&& Wo.bCanThrow )
		{
//			log ("Copy weapon for "$Killed);
			We = Spawn(Wo.Class,,,Killed.Location);
		}
		if ( We != None )
		{
//			log ("We have a copy spawned.");
			DropRot=Killed.ViewRotation;
			DropPitch=Rand(32768);
			DropYaw=Rand(65536);
			DropRot.Pitch=DropPitch;
			DropRot.Yaw=DropYaw;
			We.bWeaponStay = False;
			We.Velocity=vector(DropRot) * (Rand(250) + 250);
			We.RespawnTime=0.00;
			We.BecomePickup();
			We.NetPriority = 1.400000;
			We.NetUpdateFrequency = 10.000000;
			We.RemoteRole = ROLE_DumbProxy;
			We.SetPhysics(PHYS_Falling);
			We.bCollideWorld=True;
			We.GotoState('Pickup','dropped');
			if ( Wo != None && Wo.AmmoType != None )
				We.PickupAmmoCount = Wo.AmmoType.AmmoAmount;
//			log (We.PickupAmmoCount$" is amount for weapon dropped "$Wo);
			We.LifeSpan=60.000000; //We don't want a million thrown, right ? If have an owner I'll put back default
			Killed.Weapon = None;
			Wo.Destroy();
		}
	}
}

function bool HandlePickupQuery(Pawn Other, Inventory item, out byte bAllowPickup)
{
	local bool result;

	if ( Item != None && Item.IsA('Weapon'))
		if ( Item.MyMarker == None && Item.LifeSpan != Item.Default.LifeSpan)
		{
			Item.LifeSpan = Item.Default.LifeSpan;
		}

	if ( NextMutator != None )
		result = NextMutator.HandlePickupQuery(Other, item, bAllowPickup);
	return result;
}

function RuinStupidStuff()
{
	local int NAc;
	local Actor Any;

	ConsoleCommand("set BlockMonsters bNodelete False");
	ConsoleCommand("set BlockMonsters bStatic False");
	ConsoleCommand("set BlockMonsters bMovable True");
	ConsoleCommand("set BlockMonsters bGameRelevant False");
	ConsoleCommand("set BlockMonsters bBlockActors False");
	ConsoleCommand("set BlockMonsters bCollideActors False");
//	ConsoleCommand("set BlockMonsters bDeleteMe True");
//	Clock = appSeconds();
	NAc=0;
	foreach AllActors(class'Actor',Any)
	{
		if ( Any != None && !Any.bDeleteMe )
		{
			NAc++;
		}
	}
	log ("Helper reports the Number of Actors = "$NAc);
//	Clock = appSeconds() - Clock;
//	log ("Finished Foreach in "$Clock$" seconds.");
}

function SolveCounter()
{
	local Counter C;
	local ECounter Ec;
	local int NRep;

	foreach AllActors(class'Counter',C)
	{
		if (C != None && C.Tag != '' && !C.IsA('ECounter'))
		{
			C.SetCollision(False,False,False);
			C.SetCollisionSize(0,0);
			Ec = Spawn (class 'ECounter',,,C.Location+vect(0,0,1));
			if ( Ec != None )
			{
				log ("Proceed to tweak Counter"@C);
				Ec.NumToCount = Clamp(C.NumToCount,1,254);
				Ec.bShowMessage = True;
				Ec.CompleteMessage = C.CompleteMessage;
				Ec.CountMessage = C.CountMessage;
				Ec.Event = C.Event;
				Ec.Tag = C.Tag;
				C.Disable('Touch');
				C.Disable('Trigger');
				C.Tag = '';
				C.Event = '';
				NRep++;
			}
		}
	}
	if ( NRep > 1 )
		log ("In this Level were replaced"@NRep@"Counters.");
	else
		log ("Counter has been replaced.");
}

//native(643) static final function float AppSeconds();

defaultproperties
{
   DefaultWeapon=class'MHHelp.OLDPistol'
}