// ============================================================
// I forgot to look well at A.I. code
// This might be enough good or... damn timing...
// ============================================================

class OLDPistol expands MonsterHunt.OLDPistol;

var Sound PowerUpSounds[4];

function float RateSelf( out int bUseAltMode )
{
	local float rating;
	local Pawn P;
	local Inventory I;

	P = Pawn(Owner);
	for ( I = P.Inventory; I != None; I = I.Inventory )
	{
		if (I.IsA('osAmplifier'))
		{
			Amp = osAmplifier(I);
			break;
		}
	}

	if ( Amp != None )
		rating = 6 * AIRating;
	else
		rating = AIRating;

	if ( AmmoType.AmmoAmount <= 10 )
	{
		bUseAltMode = 0;
		return -1;
	}

	if ( Pawn(Owner).Enemy == None )
	{
		bUseAltMode = 0;
		return rating * (PowerLevel + 1);
	}
		bUseAltMode = int( FRand() < 0.3 );
	if ( powerlevel>2 ) //always use primary if the power is high...
		bUseAltMode = 0;
	return rating * (PowerLevel + 1);
}
 
simulated function PlayShootLoad()
{
	if ( PlayerPawn(Owner) != None )
		PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag*ChargeSize, ShakeVert);
	if ( Owner != None )
	{
		Owner.MakeNoise(Pawn(Owner).SoundDampening);
		PlayOwnedSound(AltFireSound, SLOT_None, 4.0*Pawn(Owner).SoundDampening);
	}
	if ( Mesh == PlayerViewMesh )
	{
		if ( PowerLevel==0 )
			PlayAnim('Shoot1',0.2, 0.05);
		else if (PowerLevel==1)
			PlayAnim('Shoot2',0.2, 0.05);
		else if (PowerLevel==2)
			PlayAnim('Shoot3',0.2, 0.05);
		else if (PowerLevel==3)
			PlayAnim('Shoot4',0.2, 0.05);  
		else if (PowerLevel==4)
			PlayAnim('Shoot5',0.2, 0.05);
	}

}

///////////////////////////////////////////////////////////
simulated function PlayIdleAnim()
{
	if (Mesh == PlayerViewMesh)
	{
	if (PowerLevel==0)
		LoopAnim('Idle1',0.04,0.2);
	else if (PowerLevel==1)
		LoopAnim('Idle2',0.04,0.2);
	else if (PowerLevel==2)
		LoopAnim('Idle3',0.04,0.2);
	else if (PowerLevel==3)
		LoopAnim('Idle4',0.04,0.2);
	else if (PowerLevel==4)
		LoopAnim('Idle5',0.04,0.2);
	}
}

simulated function PlayPowerup()
{
	if ( PowerLevel < 5 )
	{
		if ( PowerLevel==1 )
		{
			if ( Owner != None )
				PlayOwnedSound(PowerUpSounds[0], SLOT_None, 5.0*Pawn(Owner).SoundDampening);
			if ( Mesh == PlayerViewMesh )
				PlayAnim('PowerUp1',0.1, 0.05);
		}
		else if (PowerLevel==2)
		{
			if (Owner != None)
				PlayOwnedSound(PowerUpSounds[1], SLOT_None, 5.0*Pawn(Owner).SoundDampening);
			if ( Mesh == PlayerViewMesh )
				PlayAnim('PowerUp2',0.1, 0.05);
		}
		else if (PowerLevel==3)
		{
			if (Owner != None)
				PlayOwnedSound(PowerUpSounds[2], SLOT_None, 5.0*Pawn(Owner).SoundDampening);
			if ( Mesh == PlayerViewMesh )
				PlayAnim('PowerUp3',0.1, 0.05);
		}
		else if (PowerLevel==4)
		{
			if (Owner != None)
				PlayOwnedSound(PowerUpSounds[3], SLOT_None, 5.0*Pawn(Owner).SoundDampening);
			if ( Mesh == PlayerViewMesh )
				PlayAnim('PowerUp4',0.1, 0.05);
		}
	}
}
/*
simulated function PlayPowerup()
{
	if ( PowerLevel < 5 )
		Owner.PlaySound(PowerUpSound, SLOT_None, 4.0*Pawn(Owner).SoundDampening);
	if (PowerLevel==1)
		PlayAnim('PowerUp1',0.1, 0.05);  
	else if (PowerLevel==2) 
		PlayAnim('PowerUp2',0.1, 0.05);      
	else if (PowerLevel==3) 
		PlayAnim('PowerUp3',0.1, 0.05);          
	else if (PowerLevel==4) 
		PlayAnim('PowerUp4',0.1, 0.05);
}
*/
///////////////////////////////////////////////////////

simulated function TweenSelect()
{
	if ( Mesh == PlayerViewMesh )
		TweenAnim('Select1',0.001);
}

simulated function TweenToStill()     //handle powerlevels
{
	if ( Mesh == PlayerViewMesh )
	{
		if (PowerLevel==0)
			TweenAnim('Idle1',0.1);
		else if (PowerLevel==1)
			TweenAnim('Idle2',0.1);
		else if (PowerLevel==2)
			TweenAnim('Idle3',0.1);
		else if (PowerLevel==3)
			TweenAnim('Idle4',0.1);
		else if (PowerLevel==4)
			TweenAnim('Idle5',0.1);
	}
}

defaultproperties
{
     PickupAmmoCount=5000
     PowerUpSounds(0)=Sound'UnrealShare.Dispersion.number1'
     PowerUpSounds(1)=Sound'UnrealShare.Dispersion.number2'
     PowerUpSounds(2)=Sound'UnrealShare.Dispersion.number3'
     PowerUpSounds(3)=Sound'UnrealShare.Dispersion.number4'
}
