class PawnControl expands Info;

Var Pawn P;

event PrebeginPlay()
{
}

event PostBeginPlay()
{

	SetTimer(0.15,False);
}

event Timer()
{
	local Weapon W;

	if ( Pawn(Owner) != None && Pawn(Owner).Health > 0 )
		P = Pawn(Owner);

	if ( P == None || P.bDeleteMe || P.Health <= 0 )
	{
		Destroy();
		return;
	}

	if ( P != None && P.Weapon == None )
	{
		Foreach P.RadiusActors (class'Weapon',W,100)
		{
			if ( W != None && W.Instigator == P)
			{
				W.BecomeItem(); // Do not mess anims
				P.AddInventory(W);
				W.GiveAmmo(P);
			}
		}
		P.SwitchToBestWeapon();
		P.bIsPlayer = False;
		Destroy();
	}
	else
	{
		log ( Self$" detected no problem... Quitting!");
		Destroy();
	}
}