class WatchIt expands Info;

event PostBeginPlay()
{
	if ( Owner != None )
		log (Self$" spawned for "$Owner.GetHumanName());
}

event Tick (float DT)
{
	if ( bDeleteMe)
	{
		log (Self$" awaiting removal...");
		return;
	}
	else
	{
		if ( Pawn(Owner) == none || Owner.bDeleteMe )
		{
			ClearInstigators();
			log(Self$" cleaning owned data...");
		}
	}
}

function ClearInstigators()
{
	local Actor A;

	ForEach AllActors (class'Actor', A )
	{
		if ( A.Instigator == Pawn(Owner) || (A.Instigator != none && A.Instigator.bDeleteMe) )
		{
			if ( Projectile(A) != None && Projectile(A).bReplicateInstigator )
			{
				Projectile(A).bReplicateInstigator = False;
				Projectile(A).Destroy();
			}
			A.Instigator = None;
		}
	}
	Destroy();
}